<?php
/*
 * génère la liste des paquets linux à installer sur le poste.
 * aucune vérification n'est faite, on considère que apt sait faire...
 * les packages définis dans wpkg sont prioritaires sur ceux définis dans packages.list
 */
include "config.inc.php";
$config = get_config();
include ("wpkg_lib.php");
include ("wpkg_libsql.php");
include ("ldap.inc.php");

$id = $_GET["id"] ?? $_POST["id"] ?? "";
if (empty($id)) {
    exit();
}
if ($info = apcu_fetch("apps." . $id)) {
    $liste_applications = $info['liste_applications'];
    $xml = new DOMDocument();
    $xml->formatOutput = true;
    $xml->preserveWhiteSpace = false;
    $xml->load($url_packages);
    $packages = $xml->documentElement->getElementsByTagName('package');

    $liste = [];
    foreach ($packages as $package) {
        if (is_int(array_search(strtolower($package->getAttribute('id')), $liste_applications))) {
            $variables = $package->getElementsByTagName("linux");
            foreach ($variables as $variable) {
                if ($variable->getAttribute('type') == "apt") {
                    $liste[] = $variable->getAttribute('package');
                }
            }
        } 
    }
    header('Content-type: text/plain');
    echo implode(" ", $liste);
}
?>