<?php

include ("config.inc.php");
$config = get_config();
include ("ldap.inc.php");

if ($config['login'] == "")
{
    die("Authentifiez-vous pour accéder à cette fonction");
}

if (! have_right($config, "computer_is_admin")) {
    die("Droits insufisants pour accéder à cette fonction");
}

$repertoire = "/var/sambaedu/unattended/install/wpkg/rapports/";

if (isset($_GET["logfile"])) {
    $logfile = $_GET["logfile"];
} else {
    echo "Erreur! Pas de machine déclarée.";
    exit();
}

if (substr($logfile, -3)!="log")
{
    echo "Erreur! Il faut un fichier log.";
    exit();
}

header("Content-Transfer-Encoding: 8bit");
header("Content-type: text/html; charset=UTF-8");
header("Pragma: no-cache");
header("Cache-Control: max-age=5, s-maxage=5, no-cache, must-revalidate");
echo "<html><body>";
$tabfich = file($repertoire . $logfile);
foreach ($tabfich as $ligne) {
    $ligne = htmlspecialchars(utf8_encode(utf8_decode($ligne)), ENT_QUOTES);
    if (strstr($ligne, "===============================================================") or strstr($ligne, "-----")) {
        $ligne = "<b><font color='red'>" . $ligne . "</font></b>";
    }
    echo $ligne . "<br>";
}
echo "</body></html>";
?>