<?php
$list_protected_app = array(
    "wsusoffline",
    "ocs-client"
);

// localisation des repertoires

$url_packages = "/var/sambaedu/unattended/install/wpkg/packages.xml";
$wpkgroot = "/var/sambaedu/unattended/install/wpkg";
$wpkgwebdir = "/var/www/sambaedu/wpkg2";
$wpkgroot2 = "/var/sambaedu/unattended/install";

function extract_app($get_Appli, $url_packages)
{
    $xml = new DOMDocument();
    $xml->formatOutput = true;
    $xml->preserveWhiteSpace = false;
    $xml->load($url_packages);
    $element = $xml->documentElement;
    $packages = $xml->documentElement->getElementsByTagName('package');
    $length = $packages->length;

    $xml2 = new DOMDocument();
    $xml2->formatOutput = true;
    $xml2->preserveWhiteSpace = false;
    $root = $xml2->createElement("packages");
    $xml2->appendChild($root);
    // $comment=$xml2->createComment(" Fichier genere par SambaEdu. Ne pas modifier. Il contient ".($length-1)." applications. ");
    // $root->appendChild($comment);
    $packages2 = $xml2->documentElement->getElementsByTagName('package');

    foreach ($packages as $package) {
        if ($package->getAttribute('id') == $get_Appli) {
            $node = $xml2->importNode($package, true);
            $xml2->documentElement->appendChild($node);
        }
    }

    $xml2->encoding = 'UTF-8';

    return $xml2->saveXML();
    ;
}

function wpkg_poste_info($config, $id_host)
{
    //if (! $liste_poste_infos = apcu_fetch("wpkg_" . $id_host)) {
        // recuperation des donnees
        $liste_hosts = info_postes($config);
        ksort($liste_hosts);
        if (! array_key_exists($id_host, $liste_hosts)) {
            $id_host = key($liste_hosts);
        }
        $liste_poste_rapport = info_poste_rapport($config, $id_host);
        $liste_poste_app = info_poste_applications($config, $id_host);
        $liste_appli = liste_applications($config);

        $liste_poste_infos["info"] = array(
            "typewin" => $liste_hosts[$id_host]["OS_poste"],
            "status" => 0,
            "logfile" => $liste_hosts[$id_host]["file_log_poste"],
            "ip" => $liste_hosts[$id_host]["IP_poste"],
            "mac" => $liste_hosts[$id_host]["mac_address_poste"],
            "datetime" => $liste_hosts[$id_host]["date_rapport_poste"]
        );
        $liste_poste_infos["status"] = array(
            "Ok" => 0,
            "Not_Ok+" => 0,
            "Not_Ok-" => 0,
            "MaJ" => 0,
            "Nb_App" => count($liste_poste_app)
        );
        $liste_poste_infos["info"]["date"] = date('d/m/Y', strtotime($liste_poste_infos["info"]["datetime"]));
        $liste_poste_infos["info"]["time"] = date('H:i:s', strtotime($liste_poste_infos["info"]["datetime"]));
        foreach ($liste_appli as $key_md5 => $appli) {
            $liste_poste_infos["app"][$appli["id_app"]] = array(
                "id_nom_app" => $appli["id_nom_app"],
                "nom_app" => $appli["nom_app"],
                "version_app" => $appli["version_app"],
                "compatibilite_app" => $appli["compatibilite_app"],
                "categorie_app" => $appli["categorie_app"],
                "depend" => @$liste_poste_app[$appli["id_app"]]["required_by"],
                "parc" => @$liste_poste_app[$appli["id_app"]]["parc"],
                "poste" => @$liste_poste_app[$appli["id_app"]]["poste"],
                "status_app" => 0
            );
            if (isset($liste_poste_rapport[$key_md5]["revision_poste_app"])) {
                $liste_poste_infos["app"][$appli["id_app"]]["revision_poste_app"] = $liste_poste_rapport[$key_md5]["revision_poste_app"];
            } else {
                $liste_poste_infos["app"][$appli["id_app"]]["revision_poste_app"] = "-";
            }
            if (isset($liste_poste_rapport[$key_md5]["statut_poste_app"])) {
                switch ($liste_poste_rapport[$key_md5]["statut_poste_app"]) {
                    case "Installed":
                        $liste_poste_infos["app"][$appli["id_app"]]["statut_poste_app"] = "Install&#233;";
                        break;
                    case "Not Installed":
                        $liste_poste_infos["app"][$appli["id_app"]]["statut_poste_app"] = "Non Install&#233;";
                        break;
                    default:
                        $liste_poste_infos["app"][$appli["id_app"]]["statut_poste_app"] = "Inconnu";
                        break;
                }
            } else {
                $liste_poste_infos["app"][$appli["id_app"]]["statut_poste_app"] = "Inconnu";
            }
            if (array_key_exists($appli["id_app"], $liste_poste_app)) {
                if (! isset($liste_poste_rapport[$key_md5]["statut_poste_app"])) {
                    $liste_poste_infos["app"][$appli["id_app"]]["status_app"] = 2;
                    $liste_poste_infos["status"]["Not_Ok-"] ++;
                    $liste_poste_infos["info"]["status"] = max($liste_poste_infos["info"]["status"], 2);
                } elseif ($liste_poste_rapport[$key_md5]["statut_poste_app"] == "Not Installed") {
                    $liste_poste_infos["app"][$appli["id_app"]]["status_app"] = 2;
                    $liste_poste_infos["status"]["Not_Ok-"] ++;
                    $liste_poste_infos["info"]["status"] = max($liste_poste_infos["info"]["status"], 2);
                } elseif ($liste_poste_rapport[$key_md5]["revision_poste_app"] == $appli["version_app"]) {
                    $liste_poste_infos["app"][$appli["id_app"]]["status_app"] = 0;
                    $liste_poste_infos["status"]["Ok"] ++;
                } else {
                    $liste_poste_infos["app"][$appli["id_app"]]["status_app"] = 1;
                    $liste_poste_infos["status"]["MaJ"] ++;
                    $liste_poste_infos["info"]["status"] = max($liste_poste_infos["info"]["status"], 1);
                }
            } elseif (@$liste_poste_rapport[$key_md5]["statut_poste_app"] == "Installed") {
                $liste_poste_infos["app"][$appli["id_app"]]["status_app"] = 2;
                $liste_poste_infos["status"]["Not_Ok+"] ++;
                $liste_poste_infos["info"]["status"] = max($liste_poste_infos["info"]["status"], 2);
            } else {
                $liste_poste_infos["app"][$appli["id_app"]]["status_app"] = 4;
            }
        //}
        //apcu_store("wpkg_" . $id_host, $liste_poste_infos, 120);
    }
    return $liste_poste_infos;
}

function wpkg_parc_info($config, $get_parc)
{
    //if (! $info_parc = apcu_fetch("wpkg_" . $get_parc)) {

        // recuperation des donnees
        $liste_parcs = info_parcs($config); // liste des parcs
        $liste_postes_parc = info_parc_postes($config, $get_parc); // liste des postes du parc donne
        ksort($liste_parcs, SORT_STRING | SORT_FLAG_CASE);

        $info_parc['status'] = array(
            "MaJ" => 0,
            "Not_Ok" => 0,
            "Ok" => 0,
            "Total" => 0
        );
        $info_poste = array();

        foreach ($liste_postes_parc as $poste) {
            $tmp_appli = info_poste_applications($config, $poste["nom_poste"]);
            $tmp_list_key_appli = array_keys($tmp_appli);

            $info_poste[$poste["nom_poste"]]["info"] = array(
                "typewin" => $poste["OS_poste"],
                "status" => 0,
                "nb_app" => count($tmp_appli),
                "logfile" => $poste["file_log_poste"],
                "ip" => $poste["ip_poste"],
                "mac" => $poste["mac_address_poste"],
                "datetime" => $poste["date_rapport_poste"]
            );
            $info_poste[$poste["nom_poste"]]["status"] = info_poste_statut($config, $poste["id_poste"], $tmp_list_key_appli);
            $info_poste[$poste["nom_poste"]]["info"]["date"] = date('d/m/Y', strtotime($info_poste[$poste["nom_poste"]]["info"]["datetime"]));
            $info_poste[$poste["nom_poste"]]["info"]["time"] = date('H:i:s', strtotime($info_poste[$poste["nom_poste"]]["info"]["datetime"]));
            $info_poste[$poste["nom_poste"]]["info"]["status"] = @$info_poste[$poste["nom_poste"]]["status"]["status"];
            switch ($info_poste[$poste["nom_poste"]]["info"]["status"]) {
                case 0:
                    $info_parc['status']["Ok"] ++;
                    break;
                case 1:
                    $info_parc['status']["MaJ"] ++;

                    break;
                case 2:
                    $info_parc['status']["Not_Ok"] ++;
                    break;
            }
            $info_parc['status']["Total"] ++;
            $info_parc[$poste["nom_poste"]] = $info_poste[$poste["nom_poste"]]["info"]["status"];
     //   }
     //   apcu_store("wpkg_" . $get_parc, $info_parc, 120);
    }
    return $info_parc;
}
?>