<?php
include "config.inc.php";
$config = get_config();
include("wpkg_lib.php");
include("wpkg_libsql.php");
include("ldap.inc.php");

$liste_applications=liste_applications($config);
$xml = new DOMDocument;
$xml->formatOutput = true;
$xml->preserveWhiteSpace = false;
$xml->load($url_packages);
$element = $xml->documentElement;
$packages = $xml->documentElement->getElementsByTagName('package');
$length = $packages->length;
$xml2 = new DOMDocument;
$xml2->formatOutput = true;
$xml2->preserveWhiteSpace = false;
$root=$xml2->createElement("packages");
$xml2->appendChild($root);
$packages2 = $xml2->documentElement->getElementsByTagName('package');
$i=0;
foreach ($packages as $package)
{
    if (array_key_exists(hash('md5',$package->getAttribute('id')),$liste_applications))
    {
        $variables = $package->getElementsByTagName("variable");
        foreach ($variables as $key => $variable) {
            if ($variable->getAttribute('source') == "sambaedu") {
                if (!isset ($config[$variable->getAttribute('value')])){
//                    $config = set_config($config, $variable->getAttribute('value'), create_random_password(8, false), "wpkg");
                    $package->getElementsByTagName("variable")[$key]->setAttribute("value", "");
                } else {
                    $package->getElementsByTagName("variable")[$key]->setAttribute("value", $config[$variable->getAttribute('value')]);
                }
            }
        }
        $node=$xml2->importNode($package, true);
        $xml2->documentElement->appendChild($node);
        $i++;
    }
}
$comment=$xml2->createComment(" Fichier genere par SambaEdu. Ne pas modifier. Il contient ".($i)." applications. ");
$root->appendChild($comment);
$xml2->encoding = 'UTF-8';
header('Content-type: text/xml');
echo $xml2->saveXML();
?>