<?php
/**
 * Maintenance d'un poste
 * @Version $Id$
 * @Projet LCS / SambaEdu
 * @auteurs  Laurent Joly
 * @note
 * @Licence Distribue sous la licence GPL
 */
/**
 * @Repertoire: dhcp
 * file: reservations.php
*/
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("lang.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
echo header_authorize($config);
include "ihm.inc.php";
include "wpkg_lib.php";
include "wpkg_libsql.php";

$login = $config['login'];
if (! $login) {
    echo "<script language=\"JavaScript\" type=\"text/javascript\">\n<!--\n";
    $request = '/wpkg/index.php';
    echo "top.location.href = '/auth.php?request=" . rawurlencode($request) . "';\n";
    echo "//-->\n</script>\n";
    exit();
}

if (! have_right($config, "computer_is_admin"))
    die(gettext("Vous n'avez pas les droits suffisants pour acc&#233;der &#224; cette fonction") . "</BODY></HTML>");
    
    // HTMLpurifier
    $conf = HTMLPurifier_Config::createDefault();
    $purifier = new HTMLPurifier($conf);
    
	if (isset($_GET["tri"]))
		$tri=$purifier->purify($_GET["tri"])+0;
	else
		$tri=0;
	if (isset($_GET["tri2"]))
		$tri2=$purifier->purify($_GET["tri2"])+0;
	else
		$tri2=0;	
	if (isset($_GET['Appli']))
		$get_Appli=$purifier->purify($_GET['Appli']);
	else
		$get_Appli="";
	if (isset($_GET['id_host']))
		$id_host=$purifier->purify($_GET['id_host']);
	else
		$id_host="";
	if (isset($_GET["warning"]))
		$get_warning=$purifier->purify($_GET["warning"])+0;
	else
		$get_warning=1;
	if (isset($_GET["error"]))
		$get_error=$purifier->purify($_GET["error"])+0;
	else
		$get_error=1;
	if (isset($_GET["ok"]))
		$get_ok=$purifier->purify($_GET["ok"])+0;
	else
		$get_ok=1;
	if (isset($_GET["tous"]))
		$get_tous=$purifier->purify($_GET["tous"])+0;
	else
		$get_tous=0;

	echo "<form method='get' action=''>\n";
	$page_id=2;
	include ("poste_top.php");
	echo "</form>\n";

	echo "<table align='center'>\n";
	echo "<tr>\n";
		echo "<td align='center'>";
		echo "<a href='poste_maintenance_app.php?tri2=".$tri2."&id_host=".$id_host."&ok=".$get_ok."&warning=".$get_warning."&error=".$get_error."'>Choix des applications &#224; d&#233;ployer sur le poste uniquement</a>";
		echo "</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
		echo "<td align='center'>";
		echo "<a href='poste_maintenance_options.php?tri2=".$tri2."&id_host=".$id_host."&ok=".$get_ok."&warning=".$get_warning."&error=".$get_error."'>D&#233;finir la valeur des options pass&#233;es au client wpkg</a>";
		echo "</td>\n";
	echo "</tr>\n";
	echo "</table>\n";

include ("pdp.inc.php");
?>