<?php
/*
 * génère la liste des paquets winget à installer sur le poste.
 * le xml de l'application doit contenir le resultat de winget export pour l'application
 * destiné à winget import
 * aucune vérification n'est faite, on considère que winget sait faire...
 */
include "config.inc.php";
$config = get_config();
include ("wpkg_lib.php");
include ("wpkg_libsql.php");
include ("ldap.inc.php");

$id = $_GET["id"] ?? $_POST["id"] ?? "";
if (empty($id)) {
    exit();
}
$winget = $_POST["winget"] ?? $_GET["winget"] ?? "";
$local_packages = json_decode($winget, true);
if ($info = apcu_fetch("apps." . $id)) {
    $liste_applications = $info['liste_applications'];
    $xml = new DOMDocument();
    $xml->formatOutput = true;
    $xml->preserveWhiteSpace = false;
    $xml->load($url_packages);
    $packages = $xml->documentElement->getElementsByTagName('package');
    
$liste = [];
foreach ($packages as $package) {
    if (is_int(array_search(strtolower($package->getAttribute('id')), $liste_applications))) {
        $variables = $package->getElementsByTagName("windows");
        foreach ($variables as $variable) {
                if ($variable->getAttribute('type') == "winget") {
                $liste[] = $variable->getAttribute('package');
            }
            
            
        }
    }
}
}
header('Content-type: text/json');

echo implode(" ", $liste);
?>